/*
 * ABB_UI.java
 *
 * Created on 15. februar 2007, 14:06
 */

package my.ABB_UI;


import gnu.io.CommPortIdentifier;
import gnu.io.NoSuchPortException;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.io.IOException;
import java.io.*;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Scanner;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;

import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import my.ABB_UI.wisaBSwriter;

/**
 *
 * @author  Erlend
 */
public class ABB_UI extends javax.swing.JFrame {
    /**Variable name of the PacketGenerator.*/
    private PacketGenerator packGen;
    /**Variable name of the PacketReader.*/
    private PacketReader packRd;
    /**Variable name of the real-time bandwidth graph.*/
    private DynamicPlot bandwith_plot;
    /**Vairable name of the real-time jitter graph*/
    private DynamicPlot jitter_plot;
    /**Variable name of the real-time datagram loss graph.*/
    private DynamicPlot loss_plot;
    /**Variable name of the real-time data rate graph.*/
    private DynamicPlot RxRate_plot;
    /**NOT USED.*/
    private DynamicPlot TxRate_plot;
    /**NOT USED.*/
    private DynamicPlot SignalStrength_plot;
    /**Variable name of DataGenerator.*/
    private DataGenerator gen;
    /**Variable name of generatorManager.*/
    private generatorManager manager;
    /**Variable name of the COM port connected to the BS.*/
    private String comPort;
    /**Variable name of wisaBS.s*/    
    public wisaBS basestation = new wisaBS();
    
    /** Creates new form ABB_UI */
    public ABB_UI() {
        initComponents();
        try {
            
            jTextField3.setText(InetAddress.getLocalHost().getHostAddress());
        } catch (UnknownHostException ex) {
            ex.printStackTrace();
        }
        
        int height = 430;
        int width = 400;
        
        jPanel7.setSize(new Dimension(width, height));
        jPanel7.setPreferredSize(new Dimension(width, height));
        jPanel7.setMaximumSize(new Dimension(width, height));
        
        jPanel8.setSize(new Dimension(width, height));
        jPanel8.setPreferredSize(new Dimension(width, height));
        jPanel8.setMaximumSize(new Dimension(width, height));
        
        jPanel9.setSize(new Dimension(width, height));
        jPanel9.setPreferredSize(new Dimension(width, height));
        jPanel9.setMaximumSize(new Dimension(width, height));
        
        jPanel14.setSize(new Dimension(width, height));
        jPanel14.setPreferredSize(new Dimension(width, height));
        jPanel14.setMaximumSize(new Dimension(width, height));
        
        
        bandwith_plot = new DynamicPlot("Mbits/sec", 30.0);
        jitter_plot = new DynamicPlot("ms", 20.0);
        loss_plot = new DynamicPlot("%", 100.0);
        
        RxRate_plot = new DynamicPlot("Mbits/sec",60.0);
        TxRate_plot = new DynamicPlot("Mbits/sec",60.0);
        SignalStrength_plot = new DynamicPlot("%", 100.00);
        //gen = new DataGenerator(100);
        
        Dimension dim = jPanel7.getSize();
               
        Dimension d = jPanel7.getSize();
        Dimension d_plot = new Dimension(d.width-50, d.height-240);
        
        bandwith_plot.setPreferredSize(d_plot);
        jitter_plot.setPreferredSize(d_plot);
        loss_plot.setPreferredSize(d_plot);
        RxRate_plot.setPreferredSize(d_plot);
        TxRate_plot.setPreferredSize(d_plot);
        SignalStrength_plot.setPreferredSize(d_plot);
                
        jPanel7.add(bandwith_plot, BorderLayout.CENTER);
        jPanel8.add(jitter_plot, BorderLayout.CENTER);
        jPanel9.add(loss_plot, BorderLayout.CENTER);
        jPanel7.revalidate();
        
        jPanel14.add(RxRate_plot,BorderLayout.CENTER);
        this.pack();
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();
        buttonGroup3 = new javax.swing.ButtonGroup();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel4 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jRadioButton1 = new javax.swing.JRadioButton();
        jRadioButton2 = new javax.swing.JRadioButton();
        jLabel5 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jTextField2 = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jSpinner3 = new javax.swing.JSpinner();
        jSpinner1 = new javax.swing.JSpinner();
        jLabel7 = new javax.swing.JLabel();
        jTextField3 = new javax.swing.JTextField();
        jSpinner2 = new javax.swing.JSpinner();
        jLabel6 = new javax.swing.JLabel();
        jCheckBox1 = new javax.swing.JCheckBox();
        jPanel11 = new javax.swing.JPanel();
        jRadioButton82 = new javax.swing.JRadioButton();
        jRadioButton83 = new javax.swing.JRadioButton();
        jLabel10 = new javax.swing.JLabel();
        jCheckBox2 = new javax.swing.JCheckBox();
        jButton1 = new javax.swing.JButton();
        jPanel5 = new javax.swing.JPanel();
        jButton2 = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jRadioButton3 = new javax.swing.JRadioButton();
        jRadioButton4 = new javax.swing.JRadioButton();
        jRadioButton5 = new javax.swing.JRadioButton();
        jRadioButton6 = new javax.swing.JRadioButton();
        jRadioButton7 = new javax.swing.JRadioButton();
        jRadioButton8 = new javax.swing.JRadioButton();
        jRadioButton9 = new javax.swing.JRadioButton();
        jRadioButton11 = new javax.swing.JRadioButton();
        jRadioButton12 = new javax.swing.JRadioButton();
        jRadioButton13 = new javax.swing.JRadioButton();
        jRadioButton14 = new javax.swing.JRadioButton();
        jRadioButton15 = new javax.swing.JRadioButton();
        jRadioButton16 = new javax.swing.JRadioButton();
        jRadioButton17 = new javax.swing.JRadioButton();
        jRadioButton18 = new javax.swing.JRadioButton();
        jRadioButton19 = new javax.swing.JRadioButton();
        jRadioButton20 = new javax.swing.JRadioButton();
        jRadioButton21 = new javax.swing.JRadioButton();
        jRadioButton22 = new javax.swing.JRadioButton();
        jRadioButton23 = new javax.swing.JRadioButton();
        jRadioButton24 = new javax.swing.JRadioButton();
        jRadioButton25 = new javax.swing.JRadioButton();
        jRadioButton26 = new javax.swing.JRadioButton();
        jRadioButton27 = new javax.swing.JRadioButton();
        jRadioButton28 = new javax.swing.JRadioButton();
        jRadioButton29 = new javax.swing.JRadioButton();
        jRadioButton30 = new javax.swing.JRadioButton();
        jRadioButton10 = new javax.swing.JRadioButton();
        jRadioButton31 = new javax.swing.JRadioButton();
        jRadioButton32 = new javax.swing.JRadioButton();
        jRadioButton33 = new javax.swing.JRadioButton();
        jRadioButton34 = new javax.swing.JRadioButton();
        jRadioButton35 = new javax.swing.JRadioButton();
        jRadioButton36 = new javax.swing.JRadioButton();
        jRadioButton37 = new javax.swing.JRadioButton();
        jRadioButton38 = new javax.swing.JRadioButton();
        jRadioButton39 = new javax.swing.JRadioButton();
        jRadioButton40 = new javax.swing.JRadioButton();
        jRadioButton41 = new javax.swing.JRadioButton();
        jRadioButton42 = new javax.swing.JRadioButton();
        jRadioButton43 = new javax.swing.JRadioButton();
        jRadioButton44 = new javax.swing.JRadioButton();
        jRadioButton45 = new javax.swing.JRadioButton();
        jRadioButton46 = new javax.swing.JRadioButton();
        jRadioButton47 = new javax.swing.JRadioButton();
        jRadioButton48 = new javax.swing.JRadioButton();
        jRadioButton49 = new javax.swing.JRadioButton();
        jRadioButton50 = new javax.swing.JRadioButton();
        jRadioButton51 = new javax.swing.JRadioButton();
        jRadioButton52 = new javax.swing.JRadioButton();
        jRadioButton53 = new javax.swing.JRadioButton();
        jRadioButton54 = new javax.swing.JRadioButton();
        jRadioButton55 = new javax.swing.JRadioButton();
        jRadioButton56 = new javax.swing.JRadioButton();
        jRadioButton57 = new javax.swing.JRadioButton();
        jRadioButton58 = new javax.swing.JRadioButton();
        jRadioButton59 = new javax.swing.JRadioButton();
        jRadioButton60 = new javax.swing.JRadioButton();
        jRadioButton61 = new javax.swing.JRadioButton();
        jRadioButton62 = new javax.swing.JRadioButton();
        jRadioButton63 = new javax.swing.JRadioButton();
        jRadioButton64 = new javax.swing.JRadioButton();
        jRadioButton65 = new javax.swing.JRadioButton();
        jRadioButton66 = new javax.swing.JRadioButton();
        jRadioButton67 = new javax.swing.JRadioButton();
        jRadioButton68 = new javax.swing.JRadioButton();
        jRadioButton69 = new javax.swing.JRadioButton();
        jRadioButton70 = new javax.swing.JRadioButton();
        jRadioButton71 = new javax.swing.JRadioButton();
        jRadioButton72 = new javax.swing.JRadioButton();
        jRadioButton73 = new javax.swing.JRadioButton();
        jRadioButton74 = new javax.swing.JRadioButton();
        jRadioButton75 = new javax.swing.JRadioButton();
        jRadioButton76 = new javax.swing.JRadioButton();
        jRadioButton77 = new javax.swing.JRadioButton();
        jRadioButton78 = new javax.swing.JRadioButton();
        jRadioButton79 = new javax.swing.JRadioButton();
        jPanel3 = new javax.swing.JPanel();
        jRadioButton80 = new javax.swing.JRadioButton();
        jRadioButton81 = new javax.swing.JRadioButton();
        jLabel8 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jButton3 = new javax.swing.JButton();
        jPanel10 = new javax.swing.JPanel();
        jButton4 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();
        jButton6 = new javax.swing.JButton();
        jPanel6 = new javax.swing.JPanel();
        jPanel12 = new javax.swing.JPanel();
        jPanel7 = new javax.swing.JPanel();
        jTextField4 = new javax.swing.JTextField();
        jPanel8 = new javax.swing.JPanel();
        jTextField5 = new javax.swing.JTextField();
        jPanel13 = new javax.swing.JPanel();
        jPanel14 = new javax.swing.JPanel();
        jTextField6 = new javax.swing.JTextField();
        jPanel9 = new javax.swing.JPanel();
        jTextField7 = new javax.swing.JTextField();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        jMenuItem2 = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("ABBTraffic");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Traffic generation"));
        jPanel2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jPanel2MouseClicked(evt);
            }
        });

        jLabel3.setText("Protocol:");

        buttonGroup2.add(jRadioButton1);
        jRadioButton1.setSelected(true);
        jRadioButton1.setText("UDP");
        jRadioButton1.setToolTipText("The treaffic generator will generate UDP traffic.");
        jRadioButton1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jRadioButton1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jRadioButton1MouseClicked(evt);
            }
        });
        jRadioButton1.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jRadioButton1StateChanged(evt);
            }
        });
        jRadioButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton1ActionPerformed(evt);
            }
        });

        buttonGroup2.add(jRadioButton2);
        jRadioButton2.setText("TCP");
        jRadioButton2.setToolTipText("The traffic generator will generate TCP traffic.");
        jRadioButton2.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton2.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jRadioButton2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jRadioButton2MouseClicked(evt);
            }
        });
        jRadioButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton2ActionPerformed(evt);
            }
        });

        jLabel5.setText("Duration [s]:");
        jLabel5.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                jLabel5MouseEntered(evt);
            }
        });

        jLabel12.setText("Calcualtion interval [s]:");

        jLabel2.setText("Remote IP adress:");

        jTextField2.setColumns(10);
        jTextField2.setText("192.168.0.1");
        jTextField2.setToolTipText("The IP adress of the computer running the ABBServer.");

        jLabel4.setText("Bandwith [Mbits/sec]:");

        jSpinner3.setModel(new javax.swing.SpinnerNumberModel(1, 1, 54, 1));
        jSpinner3.setToolTipText("Specifies how much traffic that is attempted to transfer.");

        jSpinner1.setModel(new javax.swing.SpinnerNumberModel(10,1,600,1));
        jSpinner1.setToolTipText("The duration of traffic generation in seconds.");

        jLabel7.setText("Local IP adress:");

        jTextField3.setColumns(10);
        jTextField3.setEditable(false);
        jTextField3.setText("192.168.0.2");

        jSpinner2.setModel(new javax.swing.SpinnerNumberModel(1, 1, 600, 1));
        jSpinner2.setToolTipText("How often the meters (bandwith, jitter and packetloss) i calculated.");

        jLabel6.setText("Generate report:");

        jCheckBox1.setToolTipText("Enable to generate a report containing useful information at the end of the traffic generation.");
        jCheckBox1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox1.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jCheckBox1MouseClicked(evt);
            }
        });
        jCheckBox1.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jCheckBox1StateChanged(evt);
            }
        });

        jPanel11.setBorder(javax.swing.BorderFactory.createTitledBorder("Modes"));
        buttonGroup3.add(jRadioButton82);
        jRadioButton82.setSelected(true);
        jRadioButton82.setText("Single run");
        jRadioButton82.setToolTipText("To generate traffic only once, with the WISA basestation as configured.");
        jRadioButton82.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton82.setEnabled(false);
        jRadioButton82.setMargin(new java.awt.Insets(0, 0, 0, 0));

        buttonGroup3.add(jRadioButton83);
        jRadioButton83.setText("Double run");
        jRadioButton83.setToolTipText("To generate traffic twice, first with the WISA basestation as specified, second with the basestation off.");
        jRadioButton83.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton83.setEnabled(false);
        jRadioButton83.setMargin(new java.awt.Insets(0, 0, 0, 0));

        javax.swing.GroupLayout jPanel11Layout = new javax.swing.GroupLayout(jPanel11);
        jPanel11.setLayout(jPanel11Layout);
        jPanel11Layout.setHorizontalGroup(
            jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel11Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jRadioButton82)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jRadioButton83)
                .addContainerGap(129, Short.MAX_VALUE))
        );
        jPanel11Layout.setVerticalGroup(
            jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel11Layout.createSequentialGroup()
                .addGroup(jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButton82)
                    .addComponent(jRadioButton83))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jLabel10.setText("Display data rate:");

        jCheckBox2.setToolTipText("Enable to generate a report containing useful information at the end of the traffic generation.");
        jCheckBox2.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jCheckBox2.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jCheckBox2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jCheckBox2MouseClicked(evt);
            }
        });
        jCheckBox2.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jCheckBox2StateChanged(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel11, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel3)
                            .addComponent(jLabel5)
                            .addComponent(jLabel4)
                            .addComponent(jLabel12)
                            .addComponent(jLabel7)
                            .addComponent(jLabel2)
                            .addComponent(jLabel6)
                            .addComponent(jLabel10))
                        .addGap(39, 39, 39)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jCheckBox2)
                            .addComponent(jCheckBox1)
                            .addComponent(jTextField2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jTextField3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jSpinner1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jSpinner3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(jRadioButton2)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jRadioButton1))
                            .addComponent(jSpinner2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addContainerGap(55, Short.MAX_VALUE))))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel7)
                    .addComponent(jTextField3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextField2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addGap(9, 9, 9)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(jSpinner1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel12)
                    .addComponent(jSpinner2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(jRadioButton2)
                    .addComponent(jRadioButton1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(jSpinner3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 112, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel10)
                    .addComponent(jCheckBox2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel6)
                    .addComponent(jCheckBox1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel11, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        jButton1.setText("Start");
        jButton1.setToolTipText("Start the traffic generation.");
        jButton1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton1MouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGap(133, 133, 133)
                        .addComponent(jButton1))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton1)
                .addContainerGap(203, Short.MAX_VALUE))
        );
        jTabbedPane1.addTab("Traffic", jPanel4);

        jPanel5.setEnabled(false);
        jButton2.setText("Load to basestation");
        jButton2.setToolTipText("Load the configuration to the basestation.");
        jButton2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton2MouseClicked(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Channels"));
        jRadioButton3.setText("3");
        jRadioButton3.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton3.setEnabled(false);
        jRadioButton3.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jRadioButton3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jRadioButton3MouseClicked(evt);
            }
        });

        jRadioButton4.setText("4");
        jRadioButton4.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton4.setEnabled(false);
        jRadioButton4.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton5.setText("5");
        jRadioButton5.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton5.setEnabled(false);
        jRadioButton5.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton6.setText("6");
        jRadioButton6.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton6.setEnabled(false);
        jRadioButton6.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton7.setText("7");
        jRadioButton7.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton7.setEnabled(false);
        jRadioButton7.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton8.setText("8");
        jRadioButton8.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton8.setEnabled(false);
        jRadioButton8.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton9.setText("9");
        jRadioButton9.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton9.setEnabled(false);
        jRadioButton9.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton11.setText("10");
        jRadioButton11.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton11.setEnabled(false);
        jRadioButton11.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton12.setText("11");
        jRadioButton12.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton12.setEnabled(false);
        jRadioButton12.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton13.setText("12");
        jRadioButton13.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton13.setEnabled(false);
        jRadioButton13.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton14.setText("13");
        jRadioButton14.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton14.setEnabled(false);
        jRadioButton14.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton15.setText("14");
        jRadioButton15.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton15.setEnabled(false);
        jRadioButton15.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton16.setText("15");
        jRadioButton16.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton16.setEnabled(false);
        jRadioButton16.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton17.setText("16");
        jRadioButton17.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton17.setEnabled(false);
        jRadioButton17.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton18.setText("17");
        jRadioButton18.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton18.setEnabled(false);
        jRadioButton18.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton19.setText("18");
        jRadioButton19.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton19.setEnabled(false);
        jRadioButton19.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton20.setText("19");
        jRadioButton20.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton20.setEnabled(false);
        jRadioButton20.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton21.setText("20");
        jRadioButton21.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton21.setEnabled(false);
        jRadioButton21.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton22.setText("21");
        jRadioButton22.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton22.setEnabled(false);
        jRadioButton22.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton23.setText("22");
        jRadioButton23.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton23.setEnabled(false);
        jRadioButton23.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton24.setText("23");
        jRadioButton24.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton24.setEnabled(false);
        jRadioButton24.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton25.setText("24");
        jRadioButton25.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton25.setEnabled(false);
        jRadioButton25.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton26.setText("25");
        jRadioButton26.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton26.setEnabled(false);
        jRadioButton26.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton27.setText("26");
        jRadioButton27.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton27.setEnabled(false);
        jRadioButton27.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton28.setText("27");
        jRadioButton28.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton28.setEnabled(false);
        jRadioButton28.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton29.setText("28");
        jRadioButton29.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton29.setEnabled(false);
        jRadioButton29.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton30.setText("29");
        jRadioButton30.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton30.setEnabled(false);
        jRadioButton30.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton10.setText("30");
        jRadioButton10.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton10.setEnabled(false);
        jRadioButton10.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton31.setText("31");
        jRadioButton31.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton31.setEnabled(false);
        jRadioButton31.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton32.setText("32");
        jRadioButton32.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton32.setEnabled(false);
        jRadioButton32.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton33.setText("33");
        jRadioButton33.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton33.setEnabled(false);
        jRadioButton33.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton34.setText("34");
        jRadioButton34.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton34.setEnabled(false);
        jRadioButton34.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton35.setText("35");
        jRadioButton35.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton35.setEnabled(false);
        jRadioButton35.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton36.setText("36");
        jRadioButton36.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton36.setEnabled(false);
        jRadioButton36.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton37.setText("37");
        jRadioButton37.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton37.setEnabled(false);
        jRadioButton37.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton38.setText("38");
        jRadioButton38.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton38.setEnabled(false);
        jRadioButton38.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton39.setText("39");
        jRadioButton39.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton39.setEnabled(false);
        jRadioButton39.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton40.setText("40");
        jRadioButton40.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton40.setEnabled(false);
        jRadioButton40.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton41.setText("41");
        jRadioButton41.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton41.setEnabled(false);
        jRadioButton41.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton42.setText("42");
        jRadioButton42.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton42.setEnabled(false);
        jRadioButton42.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton43.setText("43");
        jRadioButton43.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton43.setEnabled(false);
        jRadioButton43.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton44.setText("44");
        jRadioButton44.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton44.setEnabled(false);
        jRadioButton44.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton45.setText("45");
        jRadioButton45.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton45.setEnabled(false);
        jRadioButton45.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton46.setText("46");
        jRadioButton46.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton46.setEnabled(false);
        jRadioButton46.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton47.setText("47");
        jRadioButton47.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton47.setEnabled(false);
        jRadioButton47.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton48.setText("48");
        jRadioButton48.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton48.setEnabled(false);
        jRadioButton48.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton49.setText("49");
        jRadioButton49.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton49.setEnabled(false);
        jRadioButton49.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton50.setText("50");
        jRadioButton50.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton50.setEnabled(false);
        jRadioButton50.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton51.setText("51");
        jRadioButton51.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton51.setEnabled(false);
        jRadioButton51.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton52.setText("52");
        jRadioButton52.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton52.setEnabled(false);
        jRadioButton52.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton53.setText("53");
        jRadioButton53.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton53.setEnabled(false);
        jRadioButton53.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton54.setText("54");
        jRadioButton54.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton54.setEnabled(false);
        jRadioButton54.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton55.setText("55");
        jRadioButton55.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton55.setEnabled(false);
        jRadioButton55.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton56.setText("56");
        jRadioButton56.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton56.setEnabled(false);
        jRadioButton56.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton57.setText("57");
        jRadioButton57.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton57.setEnabled(false);
        jRadioButton57.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton58.setText("58");
        jRadioButton58.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton58.setEnabled(false);
        jRadioButton58.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton59.setText("59");
        jRadioButton59.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton59.setEnabled(false);
        jRadioButton59.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton60.setText("60");
        jRadioButton60.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton60.setEnabled(false);
        jRadioButton60.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton61.setText("61");
        jRadioButton61.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton61.setEnabled(false);
        jRadioButton61.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton62.setText("62");
        jRadioButton62.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton62.setEnabled(false);
        jRadioButton62.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton63.setText("63");
        jRadioButton63.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton63.setEnabled(false);
        jRadioButton63.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton64.setText("64");
        jRadioButton64.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton64.setEnabled(false);
        jRadioButton64.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton65.setText("65");
        jRadioButton65.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton65.setEnabled(false);
        jRadioButton65.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton66.setText("66");
        jRadioButton66.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton66.setEnabled(false);
        jRadioButton66.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton67.setText("67");
        jRadioButton67.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton67.setEnabled(false);
        jRadioButton67.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton68.setText("68");
        jRadioButton68.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton68.setEnabled(false);
        jRadioButton68.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton69.setText("69");
        jRadioButton69.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton69.setEnabled(false);
        jRadioButton69.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton70.setText("70");
        jRadioButton70.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton70.setEnabled(false);
        jRadioButton70.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton71.setText("71");
        jRadioButton71.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton71.setEnabled(false);
        jRadioButton71.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton72.setText("72");
        jRadioButton72.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton72.setEnabled(false);
        jRadioButton72.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton73.setText("73");
        jRadioButton73.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton73.setEnabled(false);
        jRadioButton73.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton74.setText("74");
        jRadioButton74.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton74.setEnabled(false);
        jRadioButton74.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton75.setText("75");
        jRadioButton75.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton75.setEnabled(false);
        jRadioButton75.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton76.setText("76");
        jRadioButton76.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton76.setEnabled(false);
        jRadioButton76.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton77.setText("77");
        jRadioButton77.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton77.setEnabled(false);
        jRadioButton77.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton78.setText("78");
        jRadioButton78.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton78.setEnabled(false);
        jRadioButton78.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton79.setText("79");
        jRadioButton79.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton79.setEnabled(false);
        jRadioButton79.setMargin(new java.awt.Insets(0, 0, 0, 0));

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jRadioButton9)
                    .addComponent(jRadioButton8)
                    .addComponent(jRadioButton7)
                    .addComponent(jRadioButton6)
                    .addComponent(jRadioButton5)
                    .addComponent(jRadioButton4)
                    .addComponent(jRadioButton3))
                .addGap(12, 12, 12)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jRadioButton11)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton21)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton10)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton40)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton50)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton60)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton70))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jRadioButton12)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton22)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton31)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton41)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton51)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton61)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton71))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jRadioButton13)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton23)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton32)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton42)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton52)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton62)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton72))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jRadioButton14)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton24)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton33)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton43)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton53)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton63)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton73))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jRadioButton15)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton25)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton34)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton44)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton54)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton64)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton74))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jRadioButton16)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton26)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton35)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton45)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton55)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton65)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton75))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jRadioButton17)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton27)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton36)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton46)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton56)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton66)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton76))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jRadioButton18)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton28)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton37)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton47)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton57)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton67)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton77))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jRadioButton19)
                            .addComponent(jRadioButton20))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jRadioButton30)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jRadioButton39)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jRadioButton49)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jRadioButton59)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jRadioButton69)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jRadioButton79))
                            .addGroup(jPanel1Layout.createSequentialGroup()
                                .addComponent(jRadioButton29)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jRadioButton38)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jRadioButton48)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jRadioButton58)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jRadioButton68)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jRadioButton78)))))
                .addContainerGap(13, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButton11)
                    .addComponent(jRadioButton21)
                    .addComponent(jRadioButton10)
                    .addComponent(jRadioButton40)
                    .addComponent(jRadioButton50)
                    .addComponent(jRadioButton60)
                    .addComponent(jRadioButton70))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButton12)
                    .addComponent(jRadioButton22)
                    .addComponent(jRadioButton31)
                    .addComponent(jRadioButton41)
                    .addComponent(jRadioButton51)
                    .addComponent(jRadioButton61)
                    .addComponent(jRadioButton71))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButton13)
                    .addComponent(jRadioButton23)
                    .addComponent(jRadioButton32)
                    .addComponent(jRadioButton42)
                    .addComponent(jRadioButton52)
                    .addComponent(jRadioButton62)
                    .addComponent(jRadioButton72))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButton14)
                    .addComponent(jRadioButton24)
                    .addComponent(jRadioButton33)
                    .addComponent(jRadioButton43)
                    .addComponent(jRadioButton53)
                    .addComponent(jRadioButton63)
                    .addComponent(jRadioButton73)
                    .addComponent(jRadioButton3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButton15)
                    .addComponent(jRadioButton25)
                    .addComponent(jRadioButton34)
                    .addComponent(jRadioButton44)
                    .addComponent(jRadioButton54)
                    .addComponent(jRadioButton64)
                    .addComponent(jRadioButton74)
                    .addComponent(jRadioButton4))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButton16)
                    .addComponent(jRadioButton26)
                    .addComponent(jRadioButton35)
                    .addComponent(jRadioButton45)
                    .addComponent(jRadioButton55)
                    .addComponent(jRadioButton65)
                    .addComponent(jRadioButton75, javax.swing.GroupLayout.PREFERRED_SIZE, 15, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jRadioButton5))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButton17)
                    .addComponent(jRadioButton27)
                    .addComponent(jRadioButton36)
                    .addComponent(jRadioButton46)
                    .addComponent(jRadioButton56)
                    .addComponent(jRadioButton66)
                    .addComponent(jRadioButton76)
                    .addComponent(jRadioButton6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButton18)
                    .addComponent(jRadioButton28)
                    .addComponent(jRadioButton37)
                    .addComponent(jRadioButton47)
                    .addComponent(jRadioButton57)
                    .addComponent(jRadioButton67)
                    .addComponent(jRadioButton77)
                    .addComponent(jRadioButton7))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButton19)
                    .addComponent(jRadioButton29)
                    .addComponent(jRadioButton38)
                    .addComponent(jRadioButton48)
                    .addComponent(jRadioButton58)
                    .addComponent(jRadioButton68)
                    .addComponent(jRadioButton78)
                    .addComponent(jRadioButton8))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButton30)
                    .addComponent(jRadioButton20)
                    .addComponent(jRadioButton39)
                    .addComponent(jRadioButton49)
                    .addComponent(jRadioButton59)
                    .addComponent(jRadioButton69)
                    .addComponent(jRadioButton79)
                    .addComponent(jRadioButton9))
                .addContainerGap())
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("Options"));
        buttonGroup1.add(jRadioButton80);
        jRadioButton80.setSelected(true);
        jRadioButton80.setText("Normal");
        jRadioButton80.setToolTipText("The basestation will behave a normal.");
        jRadioButton80.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton80.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jRadioButton80.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jRadioButton80MouseClicked(evt);
            }
        });

        buttonGroup1.add(jRadioButton81);
        jRadioButton81.setText("Table");
        jRadioButton81.setToolTipText("The basestation will jump between frequencies as specified by a text file.");
        jRadioButton81.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton81.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jRadioButton81.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jRadioButton81MouseClicked(evt);
            }
        });

        jLabel8.setText("Mode:");

        jLabel1.setText("Name of text file:");

        jTextField1.setText("test.txt");

        jButton3.setText("Load");
        jButton3.setToolTipText("Load the text file specifying the frequency jump sequence.");
        jButton3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton3MouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel8)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton80)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jRadioButton81))
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, 107, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton3)))
                .addContainerGap(31, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButton81)
                    .addComponent(jRadioButton80)
                    .addComponent(jLabel8))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton3))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel10.setBorder(javax.swing.BorderFactory.createTitledBorder("Mute"));
        jButton4.setText("Mute all");
        jButton4.setToolTipText("Mute all the frequencies.");
        jButton4.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton4MouseClicked(evt);
            }
        });

        jButton5.setText("Mute none");
        jButton5.setToolTipText("Mute none of the frequencies.");
        jButton5.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton5MouseClicked(evt);
            }
        });

        jButton6.setText("Mute a WLAN channel");
        jButton6.setToolTipText("Mute the frequencies of a specific WLAN channel.");
        jButton6.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton6MouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPanel10Layout = new javax.swing.GroupLayout(jPanel10);
        jPanel10.setLayout(jPanel10Layout);
        jPanel10Layout.setHorizontalGroup(
            jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel10Layout.createSequentialGroup()
                .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel10Layout.createSequentialGroup()
                        .addGap(96, 96, 96)
                        .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jButton5)
                            .addComponent(jButton4)))
                    .addGroup(jPanel10Layout.createSequentialGroup()
                        .addGap(71, 71, 71)
                        .addComponent(jButton6)))
                .addContainerGap(89, Short.MAX_VALUE))
        );

        jPanel10Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jButton4, jButton5});

        jPanel10Layout.setVerticalGroup(
            jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel10Layout.createSequentialGroup()
                .addComponent(jButton4)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton5)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton6)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jPanel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jPanel10, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGap(87, 87, 87)
                        .addComponent(jButton2)))
                .addContainerGap(14, Short.MAX_VALUE))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 123, Short.MAX_VALUE)
                .addComponent(jButton2)
                .addContainerGap())
        );
        jTabbedPane1.addTab("WISA Basestation", jPanel5);

        jPanel6.setLayout(new javax.swing.BoxLayout(jPanel6, javax.swing.BoxLayout.X_AXIS));

        jPanel12.setLayout(new javax.swing.BoxLayout(jPanel12, javax.swing.BoxLayout.Y_AXIS));

        jPanel7.setLayout(new java.awt.BorderLayout());

        jPanel7.setBorder(javax.swing.BorderFactory.createTitledBorder("Bandwidth"));
        jPanel7.setToolTipText("A graph showing the current bandwith.");
        jTextField4.setEditable(false);
        jTextField4.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextField4.setText("The transport layer bandwidth.");
        jTextField4.setBorder(null);
        jTextField4.setMaximumSize(new java.awt.Dimension(430, 350));
        jTextField4.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel7.add(jTextField4, java.awt.BorderLayout.NORTH);

        jPanel12.add(jPanel7);

        jPanel8.setLayout(new java.awt.BorderLayout());

        jPanel8.setBorder(javax.swing.BorderFactory.createTitledBorder("Jitter"));
        jPanel8.setToolTipText("A graph showing the current jitter.");
        jTextField5.setEditable(false);
        jTextField5.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextField5.setText("The variation in the packet arrival times.");
        jTextField5.setBorder(null);
        jTextField5.setMaximumSize(new java.awt.Dimension(430, 350));
        jTextField5.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel8.add(jTextField5, java.awt.BorderLayout.NORTH);

        jPanel12.add(jPanel8);

        jPanel6.add(jPanel12);

        jPanel13.setLayout(new javax.swing.BoxLayout(jPanel13, javax.swing.BoxLayout.Y_AXIS));

        jPanel14.setLayout(new java.awt.BorderLayout());

        jPanel14.setBorder(javax.swing.BorderFactory.createTitledBorder("Rate"));
        jTextField6.setEditable(false);
        jTextField6.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextField6.setText("The current data rate.");
        jTextField6.setBorder(null);
        jTextField6.setMaximumSize(new java.awt.Dimension(430, 350));
        jTextField6.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel14.add(jTextField6, java.awt.BorderLayout.NORTH);

        jPanel13.add(jPanel14);

        jPanel9.setLayout(new java.awt.BorderLayout());

        jPanel9.setBorder(javax.swing.BorderFactory.createTitledBorder("Datagram Loss"));
        jPanel9.setToolTipText("A graph showing the current packet loss.");
        jTextField7.setEditable(false);
        jTextField7.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        jTextField7.setText("The percentage of datagrams lost during transmission.");
        jTextField7.setBorder(null);
        jTextField7.setMaximumSize(new java.awt.Dimension(430, 350));
        jTextField7.setPreferredSize(new java.awt.Dimension(20, 20));
        jPanel9.add(jTextField7, java.awt.BorderLayout.NORTH);

        jPanel13.add(jPanel9);

        jPanel6.add(jPanel13);

        jMenu1.setText("File");
        jMenuItem1.setAction(jButton1.getAction());
        jMenuItem1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jMenuItem1MouseClicked(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jMenuItem1MousePressed(evt);
            }
        });
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });

        jMenu1.add(jMenuItem1);

        jMenuBar1.add(jMenu1);

        jMenu2.setText("COM port");
        jMenuItem2.setText("Set the COM port");
        jMenuItem2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jMenuItem2MousePressed(evt);
            }
        });
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });

        jMenu2.add(jMenuItem2);

        jMenuBar1.add(jMenu2);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 338, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel6, javax.swing.GroupLayout.DEFAULT_SIZE, 739, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jTabbedPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 651, Short.MAX_VALUE)
                    .addComponent(jPanel6, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 651, Short.MAX_VALUE))
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jCheckBox2StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jCheckBox2StateChanged
// TODO add your handling code here:
    }//GEN-LAST:event_jCheckBox2StateChanged

    private void jCheckBox2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jCheckBox2MouseClicked
// TODO add your handling code here:
    }//GEN-LAST:event_jCheckBox2MouseClicked
    /**Sets the COM port connected to the BS.*/
    private void jMenuItem2MousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jMenuItem2MousePressed
        Object [] message = {"Choose the COM port the\n WISA basestation is connected to:"};
        Enumeration portList = CommPortIdentifier.getPortIdentifiers();                
        int length = 0;
        while ( portList.hasMoreElements() ) {            
            CommPortIdentifier portId = (CommPortIdentifier) portList.nextElement();
            length++;
        }
        
        Object [] possiblities = new Object[length];
        portList = CommPortIdentifier.getPortIdentifiers();                
        
        int i = 0;
        while ( portList.hasMoreElements() ) {                        
            CommPortIdentifier portId = (CommPortIdentifier) portList.nextElement();
            possiblities[i] = portId.getName();
            i++;
        }
        String s = (String) JOptionPane.showInputDialog(jPanel4, message, "Choose a COM port", JOptionPane.PLAIN_MESSAGE, null, possiblities, possiblities[0]);
        this.comPort = s;        
    }//GEN-LAST:event_jMenuItem2MousePressed

    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_jMenuItem2ActionPerformed

    private void jLabel5MouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jLabel5MouseEntered
        
    }//GEN-LAST:event_jLabel5MouseEntered
    /**Mutes WISA channels surroundig a WLAN channel.*/
    private void jButton6MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton6MouseClicked
        if(jRadioButton81.isSelected()){
//            Object[] channelWidth = {"3", "5", "7" , "9" , "11", "13", "15", "17", "19", "21", "23", "25"};
//          String a = (String) JOptionPane.showInputDialog(this, "Chose the number of WISA channels to mute:", "Ok", JOptionPane.PLAIN_MESSAGE, null, channelWidth, "17");
//            int freq_dist = Integer.parseInt(a);
            Object[] possibilities = {"1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13"};
            String s = (String) JOptionPane.showInputDialog(this, "Chose a WLAN channel to mute:", "Mute a WLAN channel", JOptionPane.PLAIN_MESSAGE, null, possibilities, "1");
            int ch = Integer.parseInt(s);
            int[] freqs = {12, 17, 22, 27, 32, 37, 42, 47, 52, 57, 62, 67, 72};
            int freq = freqs[ch-1];
            int freq_dist = 8;
            int lower_freq = freq - freq_dist;
            int higher_freq = freq + freq_dist;
            //System.out.println(lower_freq + " " + higher_freq);
            Component[] buttons = jPanel1.getComponents();
            for(int j = 0; j < buttons.length; j++){
               JRadioButton button = (JRadioButton) buttons[j];
               int button_freq = Integer.parseInt(button.getText());
               if(button.isEnabled()&&(button_freq >= lower_freq) &&(button_freq <= higher_freq)){               
                    button.setSelected(true);
               }
            }
        }
        
    }//GEN-LAST:event_jButton6MouseClicked
    /**Un-mutes all WISA channels.*/
    private void jButton5MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton5MouseClicked
        if(jRadioButton81.isSelected()){
            Component[] buttons = jPanel1.getComponents();
            for(int j = 0; j < buttons.length; j++){
               JRadioButton button = (JRadioButton) buttons[j];
               if(button.isEnabled()){
                    button.setSelected(false);
               }
            }
        }
    }//GEN-LAST:event_jButton5MouseClicked
    /**Mutes all WISA channels*/
    private void jButton4MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton4MouseClicked
        if(jRadioButton81.isSelected()){
            Component[] buttons = jPanel1.getComponents();
            for(int j = 0; j < buttons.length; j++){
               JRadioButton button = (JRadioButton) buttons[j];
               if(button.isEnabled()){
                    button.setSelected(true);
               }
            }
        }
    }//GEN-LAST:event_jButton4MouseClicked
    /**Loads a text file containing previous results.*/
    private void jMenuItem1MousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jMenuItem1MousePressed
        Object [] message = {"Specify a filename"};
        String s = (String) JOptionPane.showInputDialog(jPanel4, message, "Load file", JOptionPane.PLAIN_MESSAGE, null, null, "nameOfReportFile");
        
        ReadFile rf = new ReadFile(s, this);
        try {
            rf.read();
        } catch (FileNotFoundException ex) {
            
            Object [] options = {"OK"};
            JOptionPane.showOptionDialog(null, "File not found!", "", JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE, null, options, options[0]);
        }
    }//GEN-LAST:event_jMenuItem1MousePressed


    
    private void jMenuItem1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jMenuItem1MouseClicked
            
    }//GEN-LAST:event_jMenuItem1MouseClicked
    /**GUI operations when TCP is selected.*/
    private void jRadioButton2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jRadioButton2MouseClicked
        if(jRadioButton2.isSelected()){
            jLabel4.setEnabled(false);
            jSpinner3.setEnabled(false);
            if(jCheckBox1.isSelected()){
                setTCP();
                
                jRadioButton82.setEnabled(true);
                jRadioButton83.setEnabled(true);
            }
            if(!jCheckBox1.isSelected()){
                setTCP();
                
                jRadioButton82.setEnabled(false);
                jRadioButton83.setEnabled(false);                
            }
            
        }
    }//GEN-LAST:event_jRadioButton2MouseClicked
    /**GUI operations when UDP is selected.*/
    private void jRadioButton1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jRadioButton1MouseClicked
        if(jRadioButton1.isSelected()){
            jLabel4.setEnabled(true);
            jSpinner3.setEnabled(true);
            if(jCheckBox1.isSelected()){
                setUDP();
                
                jRadioButton82.setEnabled(true);
                jRadioButton83.setEnabled(true);
            }
            if(!jCheckBox1.isSelected()){
                setUDP();
                
                jRadioButton82.setEnabled(false);
                jRadioButton83.setEnabled(false);
            }

        }
    }//GEN-LAST:event_jRadioButton1MouseClicked

    private void setUDP(){
        jRadioButton82.setSelected(true);
        jRadioButton83.setSelected(false);
    }
    
    private void setTCP(){
        jRadioButton82.setSelected(true);
        jRadioButton83.setSelected(false);
    }
    private void jCheckBox1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jCheckBox1MouseClicked
        if(jCheckBox1.isSelected()){

            if(jRadioButton2.isSelected()){
                setTCP();
                
                jRadioButton82.setEnabled(true);
                jRadioButton83.setEnabled(true);
            }
            if(jRadioButton1.isSelected()){
                setUDP();
            
                jRadioButton82.setEnabled(true);
                jRadioButton83.setEnabled(true);
            }
            
        }
        if(!jCheckBox1.isSelected()){
            
            if(jRadioButton2.isSelected()){
                setTCP();
            
                jRadioButton82.setEnabled(false);
                jRadioButton83.setEnabled(false);
            }
            if(jRadioButton1.isSelected()){
                setUDP();
            
                jRadioButton82.setEnabled(false);
                jRadioButton83.setEnabled(false);
            }
        }
    }//GEN-LAST:event_jCheckBox1MouseClicked

    private void jCheckBox1StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jCheckBox1StateChanged
       
    }//GEN-LAST:event_jCheckBox1StateChanged

    private void jRadioButton1StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jRadioButton1StateChanged
       
    }//GEN-LAST:event_jRadioButton1StateChanged

    private void jRadioButton80MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jRadioButton80MouseClicked
       for( int i = 0; i < jPanel1.getComponents().length; i++){
            JRadioButton button = (JRadioButton) jPanel1.getComponents()[i];
            button.setEnabled(false);
            button.setSelected(false);
            
        }
    }//GEN-LAST:event_jRadioButton80MouseClicked

    private void jRadioButton81MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jRadioButton81MouseClicked
        
    }//GEN-LAST:event_jRadioButton81MouseClicked

    private void jRadioButton3MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jRadioButton3MouseClicked
        
    }//GEN-LAST:event_jRadioButton3MouseClicked
    
    /**Loads a text file containing WISA FH sequence and enables the required radiobuttons.s*/ 
    private void jButton3MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton3MouseClicked
        for( int i = 0; i < jPanel1.getComponents().length; i++){
            JRadioButton button = (JRadioButton) jPanel1.getComponents()[i];
            button.setEnabled(false);
            button.setSelected(false);
            
        }
        try {
            basestation.readFrequencyFile(jTextField1.getText());
            Component[] buttons = jPanel1.getComponents();
            for(int i = 0; i < basestation.usedFrequencies().length; i++){
                int freq = basestation.usedFrequencies()[i];
                
                for(int j = 0; j < buttons.length; j++){
                    JRadioButton button = (JRadioButton) buttons[j];
                  
                    if(button.getText().compareTo(String.valueOf(freq)) == 0){
                        button.setEnabled(true);
                        button.setSelected(false);
                    }                        
                }
            }
        } catch (FileNotFoundException ex) {
            Object [] options = {"OK"};
            JOptionPane.showOptionDialog(null, "File not found!", "", JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE, null, options, options[0]);
        } catch (NumberFormatException ex){
            Object [] options = {"OK"};
            JOptionPane.showOptionDialog(null, "There was a problem reading the file. Please check that it contains integers only.", "Reading of file failed", JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE, null, options, options[0]);
        }
    }//GEN-LAST:event_jButton3MouseClicked
    /**Start the wisaBSwriter.*/
    private void jButton2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton2MouseClicked
        basestation.muteFreq(jPanel1.getComponents());
        basestation.setMode(buttonGroup1.getElements());
        
        wisaBSwriter writer = new wisaBSwriter(basestation, comPort);
        try {
            writer.connect(comPort);
            writer.run();
        } catch (NoSuchPortException ex) {
            Object [] options = {"OK"};
            JOptionPane.showOptionDialog(null, "Please choose a COM port.", "No COM port specified!", JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE, null, options, options[0]);
        }
        
    }//GEN-LAST:event_jButton2MouseClicked
    
    private void jRadioButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton2ActionPerformed
        if(jRadioButton1.isSelected()){
            jRadioButton1.setSelected(false);
            jRadioButton2.setSelected(true);
           
        }
    }//GEN-LAST:event_jRadioButton2ActionPerformed

    private void jRadioButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton1ActionPerformed
        if(jRadioButton2.isSelected()){
            jRadioButton2.setSelected(false);
            jRadioButton1.setSelected(true);
           
        }
    }//GEN-LAST:event_jRadioButton1ActionPerformed
    /**Starts the generatorManager.*/
    private void jButton1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButton1MouseClicked
        
        try {
            if(jRadioButton83.isSelected() && jCheckBox1.isSelected()){
                wisaBSwriter wr = new wisaBSwriter(comPort);
                wr.connect(comPort);
                wr.close();
            }
            
            if((manager == null) || !manager.isAlive()){
            //System.out.println("hei");
            manager = new generatorManager();
            manager.comPort = this.comPort;
            manager.owner = this;
            
            if (jRadioButton81.isSelected()){
                manager.fileName = jTextField1.getText();
                manager.mode = "table";
            }
            if(jRadioButton80.isSelected()){
                manager.fileName = "*";
                manager.mode = "normal";
            }
            
            //UDP or not
            Enumeration buttons = buttonGroup2.getElements();
            String protocol = "UDP";
            while(buttons.hasMoreElements()){
                JRadioButton button = (JRadioButton) buttons.nextElement();
                if(button.isSelected()){
                    protocol = button.getText();
                    //System.out.println(button.getText());
                }
            }
            if(protocol.compareTo("UDP") == 0){
                manager.type = 1;
                manager.protocol = "UDP";
            } else if(protocol.compareTo("TCP") == 0){
                manager.type = 2;
                manager.protocol = "TCP";
            }                
                
            //System.out.println(manager.type);
             
            //Generate report or not
            manager.generateReport = jCheckBox1.isSelected();
            
            //run once or twice
            manager.runTwice = jRadioButton83.isSelected();
            
            //Assign real-time plots 
            manager.bandwithPlot = this.bandwith_plot;
            manager.jitterPlot = this.jitter_plot;
            manager.lossPlot = this.loss_plot;
            manager.RxRatePlot = this.RxRate_plot;            
            
            //Creating the command strings
            String simulationTime = jSpinner1.getValue().toString();
            
            String calculationInterval = jSpinner2.getValue().toString();
            manager.calculationInterval = calculationInterval;
            
            manager.localIPAdress = jTextField3.getText();
            manager.remoteIPAdress = jTextField2.getText();
            
            if(protocol.compareTo("UDP")== 0){
                String bandwith = jSpinner3.getValue().toString();
                manager.generatorBandwith = bandwith;
                manager.generatorCommand = "iperf " + "-c " + jTextField3.getText() + " -u -b " + bandwith + "M -t " + simulationTime;
                manager.receiverCommand = "iperf " + "-s " + "-u " + "-i " + calculationInterval;
            }
            if(protocol.compareTo("TCP") == 0){
                manager.generatorBandwith = "*";
                manager.generatorCommand = "iperf " + "-c " + jTextField3.getText() + " -t " + simulationTime;
                manager.receiverCommand = "iperf " + "-s " + "-i " + calculationInterval;               
            }
            manager.final_time = Integer.parseInt(simulationTime);
            if(this.jCheckBox2.isSelected()){
                manager.get_RxRate = true;
            }
            manager.channels = this.jPanel1.getComponents();
            manager.start();
        }
        
        
        } catch (NoSuchPortException ex) {
             Object [] options = {"OK"};
            JOptionPane.showOptionDialog(null, "Please choose a COM port.", "No COM port specified!", JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE, null, options, options[0]);
        }
        
        
        //If a generatorManager is not decleared or has already made its run.
        
   
    }//GEN-LAST:event_jButton1MouseClicked

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        //reader.closePacketReader();
        //generator.closeGenerator();
        if(packRd != null){
            packRd.close();
        }
    }//GEN-LAST:event_formWindowClosing
    
    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        //reader.closePacketReader();        
    }//GEN-LAST:event_formWindowClosed
        
    private void jPanel2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jPanel2MouseClicked
// TODO add your handling code here:
    }//GEN-LAST:event_jPanel2MouseClicked
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new ABB_UI().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private javax.swing.ButtonGroup buttonGroup3;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JCheckBox jCheckBox2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel13;
    private javax.swing.JPanel jPanel14;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JRadioButton jRadioButton10;
    private javax.swing.JRadioButton jRadioButton11;
    private javax.swing.JRadioButton jRadioButton12;
    private javax.swing.JRadioButton jRadioButton13;
    private javax.swing.JRadioButton jRadioButton14;
    private javax.swing.JRadioButton jRadioButton15;
    private javax.swing.JRadioButton jRadioButton16;
    private javax.swing.JRadioButton jRadioButton17;
    private javax.swing.JRadioButton jRadioButton18;
    private javax.swing.JRadioButton jRadioButton19;
    private javax.swing.JRadioButton jRadioButton2;
    private javax.swing.JRadioButton jRadioButton20;
    private javax.swing.JRadioButton jRadioButton21;
    private javax.swing.JRadioButton jRadioButton22;
    private javax.swing.JRadioButton jRadioButton23;
    private javax.swing.JRadioButton jRadioButton24;
    private javax.swing.JRadioButton jRadioButton25;
    private javax.swing.JRadioButton jRadioButton26;
    private javax.swing.JRadioButton jRadioButton27;
    private javax.swing.JRadioButton jRadioButton28;
    private javax.swing.JRadioButton jRadioButton29;
    private javax.swing.JRadioButton jRadioButton3;
    private javax.swing.JRadioButton jRadioButton30;
    private javax.swing.JRadioButton jRadioButton31;
    private javax.swing.JRadioButton jRadioButton32;
    private javax.swing.JRadioButton jRadioButton33;
    private javax.swing.JRadioButton jRadioButton34;
    private javax.swing.JRadioButton jRadioButton35;
    private javax.swing.JRadioButton jRadioButton36;
    private javax.swing.JRadioButton jRadioButton37;
    private javax.swing.JRadioButton jRadioButton38;
    private javax.swing.JRadioButton jRadioButton39;
    private javax.swing.JRadioButton jRadioButton4;
    private javax.swing.JRadioButton jRadioButton40;
    private javax.swing.JRadioButton jRadioButton41;
    private javax.swing.JRadioButton jRadioButton42;
    private javax.swing.JRadioButton jRadioButton43;
    private javax.swing.JRadioButton jRadioButton44;
    private javax.swing.JRadioButton jRadioButton45;
    private javax.swing.JRadioButton jRadioButton46;
    private javax.swing.JRadioButton jRadioButton47;
    private javax.swing.JRadioButton jRadioButton48;
    private javax.swing.JRadioButton jRadioButton49;
    private javax.swing.JRadioButton jRadioButton5;
    private javax.swing.JRadioButton jRadioButton50;
    private javax.swing.JRadioButton jRadioButton51;
    private javax.swing.JRadioButton jRadioButton52;
    private javax.swing.JRadioButton jRadioButton53;
    private javax.swing.JRadioButton jRadioButton54;
    private javax.swing.JRadioButton jRadioButton55;
    private javax.swing.JRadioButton jRadioButton56;
    private javax.swing.JRadioButton jRadioButton57;
    private javax.swing.JRadioButton jRadioButton58;
    private javax.swing.JRadioButton jRadioButton59;
    private javax.swing.JRadioButton jRadioButton6;
    private javax.swing.JRadioButton jRadioButton60;
    private javax.swing.JRadioButton jRadioButton61;
    private javax.swing.JRadioButton jRadioButton62;
    private javax.swing.JRadioButton jRadioButton63;
    private javax.swing.JRadioButton jRadioButton64;
    private javax.swing.JRadioButton jRadioButton65;
    private javax.swing.JRadioButton jRadioButton66;
    private javax.swing.JRadioButton jRadioButton67;
    private javax.swing.JRadioButton jRadioButton68;
    private javax.swing.JRadioButton jRadioButton69;
    private javax.swing.JRadioButton jRadioButton7;
    private javax.swing.JRadioButton jRadioButton70;
    private javax.swing.JRadioButton jRadioButton71;
    private javax.swing.JRadioButton jRadioButton72;
    private javax.swing.JRadioButton jRadioButton73;
    private javax.swing.JRadioButton jRadioButton74;
    private javax.swing.JRadioButton jRadioButton75;
    private javax.swing.JRadioButton jRadioButton76;
    private javax.swing.JRadioButton jRadioButton77;
    private javax.swing.JRadioButton jRadioButton78;
    private javax.swing.JRadioButton jRadioButton79;
    private javax.swing.JRadioButton jRadioButton8;
    private javax.swing.JRadioButton jRadioButton80;
    private javax.swing.JRadioButton jRadioButton81;
    private javax.swing.JRadioButton jRadioButton82;
    private javax.swing.JRadioButton jRadioButton83;
    private javax.swing.JRadioButton jRadioButton9;
    private javax.swing.JSpinner jSpinner1;
    private javax.swing.JSpinner jSpinner2;
    private javax.swing.JSpinner jSpinner3;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JTextField jTextField3;
    private javax.swing.JTextField jTextField4;
    private javax.swing.JTextField jTextField5;
    private javax.swing.JTextField jTextField6;
    private javax.swing.JTextField jTextField7;
    // End of variables declaration//GEN-END:variables
    
}
