/*
 * DataGenerator.java
 *
 * Created on 24. mars 2007, 14:10
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package my.ABB_UI;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Scanner;
import javax.swing.Timer;
import org.jfree.data.time.Second;
import org.jfree.data.time.TimeSeries;
import org.jfree.data.xy.XYSeries;

/**
 *
 * @author Erlend
 */
class DataGenerator extends Timer implements ActionListener {
        /**Variable name of PacketReader*/
        private PacketReader packRd;
        /**Variable name of RxRateReader*/
        private RxRateReader rxRateReader;
        /**Variable name of real-time bandwidth graph*/
        private DynamicPlot bandwith_plot;
        /**Variable name of real-time jitter graph.*/
        private DynamicPlot jitter_plot;
        /**Variable name of real-time datagram loss graph.*/
        private DynamicPlot loss_plot;
        private DynamicPlot plot;
        /**Variable name of real-time data rate graph.*/
        private DynamicPlot RxRatePlot;
        /**For setting the protocol.*/
        private int type;
        /**XYSerie for bandwidth data, first run.*/
        private XYSeries bandwithSerie_1 = new XYSeries("Basestation ON");
        /**XYSerie for jitter data, first run.*/
        private XYSeries jitterSerie_1 = new XYSeries("Basestation ON");
        /**XYSerie for datagram loss data, first run.*/
        private XYSeries lossSerie_1 = new XYSeries("Basestation ON");
        /**XYSerie for bandwidth data, second run.*/
        private XYSeries bandwithSerie_2 = new XYSeries("Basestation OFF");
        /**XYSerie for jitter data, second run.*/
        private XYSeries jitterSerie_2 = new XYSeries("Basestation OFF");
        /**XYSerie for datagram loss data, second run.*/
        private XYSeries lossSerie_2 = new XYSeries("Basestation OFF");
        /**XYSerie for data rate data, first run.*/
        private XYSeries rxRateSerie_1 = new XYSeries("Basestation ON");
        /**XYSerie for data rate data, second run.*/
        private XYSeries rxRateSerie_2 = new XYSeries("Basestation OFF");
                
        
        public boolean hasRun = false;
    /**
    * Constructor.
    *
    * @param interval the interval (in milliseconds)
    */
        public DataGenerator(int interval) {
           // packRd = p;
            super(interval, null);
            addActionListener(this);
        }
        
        public void setType(int t){
            type = t;
        }
        
        
        public void setReader(PacketReader p){
            packRd = p;
        }
        
        public void setRxReader(RxRateReader r){
            this.rxRateReader = r;
        }
        
        public void setSinglePlot(DynamicPlot plot){
            this.plot = plot;
        }
        
        public void setPlot(DynamicPlot bandwith_plot, DynamicPlot jitter_plot, DynamicPlot loss_plot, DynamicPlot rx_plot){
            this.bandwith_plot = bandwith_plot;
            this.jitter_plot = jitter_plot;
            this.loss_plot = loss_plot;
            this.RxRatePlot = rx_plot;
            
        }
        /**
         * Resets the XYSeries
         */
        public void resetSeries(){
            bandwithSerie_1.clear();
            jitterSerie_1.clear();
            lossSerie_1.clear();
            rxRateSerie_1.clear();
            
            bandwithSerie_2.clear();
            jitterSerie_2.clear();
            lossSerie_2.clear();
            rxRateSerie_1.clear();
        }
        /**
         *Returns a bandwidth XYSereie.
         *@param 1 = first run, 2 = second run.
         */
        public XYSeries getBandwithSerie(int i){
            if(i == 1)
                return bandwithSerie_1;
            else 
                return bandwithSerie_2;
        }
        /**
         *Returns a jitter XYSerie.
         *@param 1 = first run, 2 = second run.
         */
        public XYSeries getJitterSerie(int i){
            if(i == 1)
                return jitterSerie_1;
            else
                return jitterSerie_2;
        }
        /**
         *Reurns a datagram loss XYSerie.
         *@param 1 = first run, 2 = second run.
         */
        public XYSeries getLossSerie(int i){
            if(i == 1)
                return lossSerie_1;
            else
                return lossSerie_2;
                    
        }
        /**Returns a data rate XYSerie.
         *@param 1 = first run, 2 = second run.
         */
        public XYSeries getRxRateSerie(int i){
            if(i == 1)
                return rxRateSerie_1;
            else
                return rxRateSerie_2;
                    
        }       
        
        public void actionPerformed(ActionEvent event) {            
                        
            if((packRd.isUpdated()) && (type == 1)){
               double b = packRd.fetchBandwith();
               double j = packRd.fetchJitter();
               double p = packRd.fetchLoss();
               double t = packRd.fetchSecondTime();
            
               
               if(!hasRun){
                    bandwithSerie_1.add(t, b);
                    jitterSerie_1.add(t, j);
                    lossSerie_1.add(t, p);                    
                    if(this.rxRateReader.isAlive()){
                        this.RxRatePlot.addObservation(this.rxRateReader.rxRate);
                        this.rxRateSerie_1.add(t, this.rxRateReader.rxRate);
                    }
               }
               if(hasRun){
                   bandwithSerie_2.add(t,b);
                   jitterSerie_2.add(t,j);
                   lossSerie_2.add(t,p);
                   if(this.rxRateReader.isAlive()){
                    this.RxRatePlot.addObservation(this.rxRateReader.rxRate);
                    this.rxRateSerie_2.add(t, this.rxRateReader.rxRate);
                   }
               }
               
               packRd.isRead();
    
               bandwith_plot.addObservation(b);
               jitter_plot.addObservation(j);
               loss_plot.addObservation(p);
               
               
            }
            if((packRd.isUpdated()) && (type == 2)){
               double b = packRd.fetchBandwith();
               double t = packRd.fetchSecondTime();
               
               packRd.isRead();
               bandwith_plot.addObservation(b);
               
               if(!hasRun){
                    bandwithSerie_1.add(t, b);
                    if(this.rxRateReader.isAlive()){
                        this.RxRatePlot.addObservation(this.rxRateReader.rxRate);
                        this.rxRateSerie_1.add(t, this.rxRateReader.rxRate);
                    }
               }
               if(hasRun){
                   bandwithSerie_2.add(t,b);
                   if(this.rxRateReader.isAlive()){
                        this.RxRatePlot.addObservation(this.rxRateReader.rxRate);
                        this.rxRateSerie_2.add(t, this.rxRateReader.rxRate);
                   }
               }
            }
        }
    }