/*
 * PacketReader.java
 *
 * Created on 21. februar 2007, 22:37
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package my.ABB_UI;

import java.io.*;

/**
 *
 * @author Erlend
 */
public class PacketReader extends Thread {
    
    private Runtime rt = Runtime.getRuntime();    
    private Process proc;
    private String receiverCommand;
    private BufferedReader reader;
    private DynamicPlot plot;
    private double first_time, second_time, bandwith, jitter, percentage;
    private boolean updated = false;
    public boolean hasRun = false;
    private int type;
    public int final_time;
    
    /** Creates a new instance of PacketReader */
    public PacketReader(){
       
    }
    
    public void setType(int t){
        type = t;
    }
       
    public void setPlot(DynamicPlot p){
        plot = p;
    }
    
    public void setReceiverCommand(String cmd){
        receiverCommand = cmd;
    }
    
    public void close(){
        if(proc != null){
            proc.destroy();
        }
    }
    
    public double fetchBandwith(){
        return bandwith;
    }
    
    public double fetchFirstTime(){
        return first_time;
    }
    
    public double fetchJitter(){
        return jitter;
    }
    
    public double fetchSecondTime(){
        return second_time;
    }
    
    public double fetchLoss(){
        return percentage;
    }
    
    public boolean isUpdated(){
        return updated;
    }
    
    public void isRead(){
        updated = false;
    }
    
    private double getPercentageLoss(String s){
        int higher_index = s.indexOf("(");
        int lower_index = s.indexOf("ms") +2;
        String percentage = s.substring(lower_index, higher_index).trim();
        int line_placement = percentage.indexOf("/");
        double loss = Double.valueOf(percentage.substring(0,line_placement).trim());
        double trans = Double.valueOf(percentage.substring(line_placement+1,percentage.length()).trim());
        
        double perc = (loss/trans)*100;
        
        if (perc > 100.0)
            return 0.0;
        else
            return perc;
    
    }
    
    private double getJitter(String s){
        int bandwith_placement = s.indexOf("bits/sec") +8;
        int jitter_placement = s.indexOf("ms") -1;
        String jitter = s.substring(bandwith_placement, jitter_placement).trim();
        
        return Double.valueOf(jitter);
    }    
    
    private double getBandwith(String s){
        boolean change = false;
        int bandwith_placement = s.indexOf("bits/sec") -2;
        
        if(s.substring(bandwith_placement+1, bandwith_placement+2).compareTo("M") != 0){
            
            change = true;
        }
        int transfer_placement = s.indexOf("Bytes") + 5;
        String bandwith = s.substring(transfer_placement, bandwith_placement).trim();
        
        if(change){
            Double K = Double.valueOf(bandwith);
            return K/1000;
        }        
        return Double.valueOf(bandwith);
        
    }
    
    private double getLowerTime(String s){
        int time_placement = s.indexOf("sec");
        String time_string = s.substring(5, (time_placement-1)).trim();
        int line_placement = time_string.indexOf("-");                   
        String lower_time = time_string.substring(0,line_placement-1);
        return Double.valueOf(lower_time);
    }
    
    private double getHigherTime(String s){
        int time_placement = s.indexOf("sec");
        String time_string = s.substring(5, (time_placement-1)).trim();
        int line_placement = time_string.indexOf("-");      
        String higher_time = time_string.substring(line_placement+1, time_string.length()).trim();
        
        return Double.valueOf(higher_time);
    }
     
    public void run(){
        try {          
            proc = rt.exec(receiverCommand);
            reader = new BufferedReader(new InputStreamReader(proc.getInputStream()));
            String lineRead;
            
            while((lineRead = reader.readLine()) != null){
                //System.out.println(lineRead); //You can send output from here to a GUI display if needed               
                int time_placement = lineRead.indexOf("sec");
                   
                if(time_placement != -1){
                   if(type == 1){
                           first_time = getLowerTime(lineRead);
                            second_time = getHigherTime(lineRead);

                            if((first_time == 0.0) && (((int)second_time) >= final_time)){
                                break;
                            }
                            if(lineRead.trim().compareTo("1 datagrams received out-of-order") != 0){
                                bandwith = getBandwith(lineRead);
                                jitter = getJitter(lineRead);
                                percentage = getPercentageLoss(lineRead);
                                updated = true;    
                            }
                            
    
                    }
                   if(type == 2){
                            first_time = getLowerTime(lineRead);
                            second_time = getHigherTime(lineRead);

                            if((first_time == 0.0) && (((int)second_time) >= final_time)){
                                break;
                            }
                            if(lineRead.trim().compareTo("1 datagrams received out-of-order") != 0){
                                bandwith = getBandwith(lineRead);
                                updated = true;                          
                            }
                   }
                }
            }
            
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        proc.destroy();
        hasRun = true;
    }
    
}
