/*
 * ReadFile.java
 *
 * Created on 23. april 2007, 10:23
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package my.ABB_UI;

import java.awt.ComponentOrientation;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.Scanner;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;

/**
 *
 * @author ABB
 */
public class ReadFile {
    
    private String fileName;
    public DynamicPlot bandwithPlot;
    public DynamicPlot jitterPlot;
    public DynamicPlot lossPlot;
    private DataGenerator gen;
    
    //public JDialog reportFrame;
    public JFrame reportFrame;
    public JFrame owner;
    public JPanel base;
    public JPanel graphPanel;
    public JPanel otherPanel;
    public JPanel summaryPanel;
    public JPanel parametersPanel;
    public JPanel onPanel;
    public JPanel offPanel;
    public JPanel diffPanel;
    public JPanel reportPanel;
    public JPanel savePanel;
        
    public String date;
    public String startTime;
    public String stopTime;
    public String totalTime;
    public boolean table;
    public String saveFileName;
    public String generatorBandwith;
    public String calculationInterval;
    public String protocol;
    public String localIPAdress;
    public String remoteIPAdress;
    public String mode;
    public int final_time;
    
    private XYSeries bandwithSerie_1 = null;
    private XYSeries bandwithSerie_2 = null;
    private XYSeries jitterSerie_1 = null;
    private XYSeries jitterSerie_2 = null;
    private XYSeries lossSerie_1 = null;
    private XYSeries lossSerie_2 = null;
    private XYSeries rxRateSerie_1 = null;
    private XYSeries rxRateSerie_2 = null;
    
    private JLabel startLabel;
    private JLabel stopLabel;
    private JLabel emptyLabel_1 ;
    private JLabel protocolLabel;
    private JLabel bandwithLabel;
    private JLabel intervalLabel;
    private JLabel remoteIPLabel;
    private JLabel localIPLabel;
    private JLabel emptyLabel_2;
    private JLabel modeLabel;
    private JLabel fileNameLabel;
    
    private XYSeriesCollection bandwithData;
    private XYSeriesCollection jitterData;
    private XYSeriesCollection lossData;
    private XYSeriesCollection rateData;
    
    /** Creates a new instance of ReadFile */
    public ReadFile(String fileName, JFrame owner) {
        this.fileName = fileName;
        this.owner = owner;
    
    }
    
    private String[] readItem(String dataString){
        int middle = dataString.indexOf("--");
        String time = dataString.substring(0,middle).trim();
        String value = dataString.substring((middle + 2)).trim();
        String[] result = {time, value};
        
        return result;
    }
    
    private void readData(XYSeries serie, Scanner s){
        String temp = s.next();    
        while(s.hasNext()){
            temp = s.next().trim();
            if((temp == "**********************************************************") || (temp.indexOf("--") == -1)) {
                break;
            }
            String[] item = readItem(temp);            
            serie.add(Double.parseDouble(item[0]), Double.parseDouble(item[1]));
            
        }
        
    }
    public double getMaximumValue(XYSeries serie){
        double max = 0.0;
        for(int i = 1; i < serie.getItemCount(); i++){
            double temp =  serie.getDataItem(i).getY().doubleValue();
            if( temp > max){
                max = temp;
            }
        }
        
        return max;
    }
    
    public double getMinimumValue(XYSeries serie){
        double min = 1000.0;
        for(int i = 1; i < serie.getItemCount(); i++){
            double temp = serie.getDataItem(i).getY().doubleValue();
            if(temp < min){
                min = temp;
            }
        }
        return min;
    }
    
    public double getAverageValue(XYSeries serie){
        double sum = 0.0;
        for(int i = 1; i < serie.getItemCount(); i++){
            sum = sum + serie.getDataItem(i).getY().doubleValue();
        }
        return (sum/(serie.getItemCount()-1));
    }
    
    public JScrollPane createTCPTable(XYSeries bandwithSerie, XYSeries rxRateSerie){
        String [] columnNames = {"", "Average", "Best", "Worst"};
        Object [][] data = {{"Bandwidth [Mbits/sec]", getAverageValue(bandwithSerie), getMaximumValue(bandwithSerie), getMinimumValue(bandwithSerie)},
                            {"Rate [Mbits/sec]", getAverageValue(rxRateSerie), getMaximumValue(rxRateSerie), getMinimumValue(rxRateSerie)}};
        
        
        JTable table = new JTable(data, columnNames);
        JScrollPane scroll = new JScrollPane(table);
        scroll.setMaximumSize(new Dimension(500, 53));
        scroll.setMinimumSize(new Dimension(500,53));
        scroll.setPreferredSize(new Dimension(500,53));
        table.setPreferredScrollableViewportSize(table.getSize());
        
        return scroll;
    }

    public XYSeriesCollection getBandwithData() {
        return bandwithData;
    }
       
    public JScrollPane createUDPTable(XYSeries bandwithSerie, XYSeries jitterSerie, XYSeries lossSerie, XYSeries rxRateSerie){
        String [] columnNames= {"", "Average", "Best", "Worst"};
        Object [][] data = {{"Bandwidth [Mbits/sec]", getAverageValue(bandwithSerie), getMaximumValue(bandwithSerie), getMinimumValue(bandwithSerie)},
            {"Jitter [Ms]", getAverageValue(jitterSerie), getMaximumValue(jitterSerie), getMinimumValue(jitterSerie)},
            {"Datagram loss [%]", getAverageValue(lossSerie), getMaximumValue(lossSerie), getMinimumValue(lossSerie)},
            {"Rate [Mbits/sec]", getAverageValue(rxRateSerie), getMaximumValue(rxRateSerie), getMinimumValue(rxRateSerie)}};
        
        JTable table = new JTable(data, columnNames);
        JScrollPane scroll = new JScrollPane(table);
        scroll.setMaximumSize(new Dimension(500, 83));
        scroll.setMinimumSize(new Dimension(500,83));
        scroll.setPreferredSize(new Dimension(500,83));
        table.setPreferredScrollableViewportSize(table.getSize());
        
        return scroll;
    }
    
    public void read() throws FileNotFoundException{
        
        
        Scanner s = null;
        s = new Scanner(new BufferedReader(new FileReader(fileName)));
        s.useDelimiter("\n\\s*");
        this.layoutComponents();
        startLabel.setText(s.next());
        stopLabel.setText(s.next());
        protocolLabel.setText(s.next());
        bandwithLabel.setText(s.next());
        intervalLabel.setText(s.next());
        localIPLabel.setText(s.next());
        remoteIPLabel.setText(s.next());
        modeLabel.setText(s.next());
        fileNameLabel.setText(s.next());
                
        while(s.hasNext()){            
            String temp = s.next().trim(); 
            if(temp.compareTo("Bandwidth data (1st run)") == 0){
                bandwithSerie_1 = new XYSeries("Basestation ON");                
                readData(this.bandwithSerie_1, s);
                bandwithData = new XYSeriesCollection();
                bandwithData.addSeries(bandwithSerie_1);
                this.bandwithSerie_1.setDescription("Basestation ON");
            }                
            if(temp.compareTo("Bandwidth data (2nd run)") == 0){
                bandwithSerie_2 = new XYSeries("Basestation OFF");
                readData(this.bandwithSerie_2, s);
                bandwithData.addSeries(bandwithSerie_2);
                this.bandwithSerie_1.setDescription("Basestation OFF");
            }            
            if(temp.compareTo("Jitter data (1st run)") == 0){
                jitterSerie_1 = new XYSeries("Basestation ON");
                readData(this.jitterSerie_1, s);
                jitterData = new XYSeriesCollection();
                jitterData.addSeries(this.jitterSerie_1);
                this.jitterSerie_1.setDescription("Basestation ON");
            }            
            if(temp.compareTo("Jitter data (2nd run)") == 0){
                jitterSerie_2 = new XYSeries("Basestation OFF");
                readData(this.jitterSerie_2, s);
                jitterData.addSeries(this.jitterSerie_2);
                this.jitterSerie_2.setDescription("Basestation OFF");
            }
            if(temp.compareTo("Datagram loss data (1st run)") == 0){
                lossSerie_1 = new XYSeries("Basestation ON");
                readData(this.lossSerie_1, s);
                lossData = new XYSeriesCollection();
                lossData.addSeries(this.lossSerie_1);
                this.lossSerie_1.setDescription("Basestation ON");
            }
            if(temp.compareTo("Rate data (1st run)") == 0){
                rxRateSerie_1 = new XYSeries("Basestation ON");
                readData(this.rxRateSerie_1, s);
                rateData = new XYSeriesCollection();
                rateData.addSeries(this.rxRateSerie_1); 
                this.rxRateSerie_1.setDescription("Basestation ON");
            }
            if(temp.compareTo("Datagram loss data (2nd run)") == 0){
                lossSerie_2 = new XYSeries("Basestation OFF");
                readData(this.lossSerie_2, s);
                lossData.addSeries(this.lossSerie_2); 
                this.lossSerie_1.setDescription("Basestation OFF");
            }            
            if(temp.compareTo("Rate data (2nd run)") == 0){
                rxRateSerie_2= new XYSeries("Basestation OFF");
                readData(this.rxRateSerie_2, s);
                rateData.addSeries(this.rxRateSerie_2); 
                this.rxRateSerie_2.setDescription("Basestation OFF");
            }
        }
        
        if(this.bandwithSerie_1 != null){
            JFreeChart bandwithChart = ChartFactory.createXYLineChart("Bandwidth", "Time [s]", "Mbits/sec", bandwithData, PlotOrientation.VERTICAL, true, true, false);
            ChartPanel bandwithPanel = new ChartPanel(bandwithChart);
            bandwithPanel.setPreferredSize(new Dimension(500,150));
            bandwithPanel.setMaximumSize(new Dimension(500,150));
            
            graphPanel.add(bandwithPanel);
        }
        if(this.jitterSerie_1 != null){
            JFreeChart jitterChart = ChartFactory.createXYLineChart("Jitter", "Time [s]", "ms", jitterData, PlotOrientation.VERTICAL, true, true, false);
            ChartPanel jitterPanel = new ChartPanel(jitterChart);
            jitterPanel.setPreferredSize(new Dimension(500,150));
            jitterPanel.setMaximumSize(new Dimension(500,150));
            
            graphPanel.add(jitterPanel);
        }
        if(this.lossSerie_1 != null){
            JFreeChart lossChart = ChartFactory.createXYLineChart("Datagram loss", "Time [s]", "%", lossData, PlotOrientation.VERTICAL, true, true, false);
            ChartPanel lossPanel = new ChartPanel(lossChart);
            lossPanel.setPreferredSize(new Dimension(500,150));
            lossPanel.setMaximumSize(new Dimension(500,150));
            
            //System.out.println("Hei");
            graphPanel.add(lossPanel);
        }
        if(this.rxRateSerie_1 != null){
            JFreeChart rateChart = ChartFactory.createXYLineChart("Rate", "Time [s]", "Mbits/sec", rateData, PlotOrientation.VERTICAL, true, true, false);
            ChartPanel ratePanel = new ChartPanel(rateChart);
            ratePanel.setPreferredSize(new Dimension(500,150));
            ratePanel.setMaximumSize(new Dimension(500,150));
            
            graphPanel.add(ratePanel);
        }
        
        if((bandwithSerie_1 != null) && (jitterSerie_1 == null) &&(bandwithSerie_2 == null)){
            //run once with TCP
            JScrollPane table = createTCPTable(bandwithSerie_1, rxRateSerie_1);
                    
            JPanel tabelPanel = new JPanel();
            tabelPanel.add(table);
            tabelPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Basestation ON"));
            tabelPanel.setLayout(new BoxLayout(tabelPanel, javax.swing.BoxLayout.Y_AXIS));
            summaryPanel.add(tabelPanel);
        }
        
        if((bandwithSerie_1 != null) && (bandwithSerie_2 != null) && (jitterSerie_1 == null)){
            //run twice with TCP
            JScrollPane table_1 = createTCPTable(bandwithSerie_1, rxRateSerie_1);
            JPanel tabelPanel_1 = new JPanel();
            tabelPanel_1.setLayout(new BoxLayout(tabelPanel_1, javax.swing.BoxLayout.X_AXIS));
            tabelPanel_1.add(table_1);
            tabelPanel_1.setBorder(javax.swing.BorderFactory.createTitledBorder("Basestation ON"));
            summaryPanel.add(tabelPanel_1);
            
            JScrollPane table_2 = createTCPTable(bandwithSerie_2, rxRateSerie_2);
            JPanel tabelPanel_2 = new JPanel();
            tabelPanel_2.setLayout(new BoxLayout(tabelPanel_2, javax.swing.BoxLayout.X_AXIS));
            tabelPanel_2.add(table_2);
            tabelPanel_2.setBorder(javax.swing.BorderFactory.createTitledBorder("Basestation OFF"));
            summaryPanel.add(tabelPanel_2);
        }
        
        if((bandwithSerie_1 != null) && (bandwithSerie_2 == null) && (jitterSerie_1 != null)){
            //rune once with UDP
            JScrollPane udpTable = createUDPTable(bandwithSerie_1, jitterSerie_1, lossSerie_1, rxRateSerie_1);
                    
            JPanel tabelPanel = new JPanel();
            tabelPanel.add(udpTable);
            tabelPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Basestation ON"));
            tabelPanel.setLayout(new BoxLayout(tabelPanel, javax.swing.BoxLayout.X_AXIS));
            summaryPanel.add(tabelPanel);
        }
        
        if((bandwithSerie_1 != null) && (bandwithSerie_2 != null) && (jitterSerie_1 != null)){
            //rune twice with UDP
            JScrollPane table_1 = createUDPTable(bandwithSerie_1, jitterSerie_1, lossSerie_1, rxRateSerie_1);
            JPanel tabelPanel_1 = new JPanel();
            tabelPanel_1.setLayout(new BoxLayout(tabelPanel_1, javax.swing.BoxLayout.X_AXIS));
            tabelPanel_1.add(table_1);
            tabelPanel_1.setBorder(javax.swing.BorderFactory.createTitledBorder("Basestation ON"));
            summaryPanel.add(tabelPanel_1);

            JScrollPane table_2 = createUDPTable(bandwithSerie_2, jitterSerie_2, lossSerie_2, rxRateSerie_2);
            JPanel tabelPanel_2 = new JPanel();
            tabelPanel_2.setLayout(new BoxLayout(tabelPanel_2, javax.swing.BoxLayout.X_AXIS));
            tabelPanel_2.add(table_2);
            tabelPanel_2.setBorder(javax.swing.BorderFactory.createTitledBorder("Basestation OFF"));
            summaryPanel.add(tabelPanel_2);
        }
        

        otherPanel.add(parametersPanel);        

        graphPanel.validate();
        otherPanel.add(summaryPanel);
        summaryPanel.validate();

        parametersPanel.validate();

        reportFrame.pack();
        reportFrame.setVisible(true);
        reportFrame.setAlwaysOnTop(false);
        
        s.close();
    }
    
    private void layoutComponents(){
        reportFrame = new JFrame();
        reportFrame.setAlwaysOnTop(false);
        
                
        base = new JPanel(true);
        base.setLayout(new BoxLayout(base, javax.swing.BoxLayout.Y_AXIS));
        reportFrame.getContentPane().add(base);
        
        reportPanel = new JPanel(true);
        reportPanel.setLayout(new BoxLayout(reportPanel, javax.swing.BoxLayout.X_AXIS));
        base.add(reportPanel);
        
        savePanel = new JPanel(true);
        savePanel.setLayout(new BoxLayout(savePanel, javax.swing.BoxLayout.X_AXIS));
        base.add(savePanel);
            
        otherPanel = new JPanel(true);
        otherPanel.setLayout(new BoxLayout(otherPanel, javax.swing.BoxLayout.Y_AXIS));
        reportPanel.add(otherPanel);
        
        graphPanel = new JPanel(true);
        graphPanel.setLayout(new BoxLayout(graphPanel, javax.swing.BoxLayout.Y_AXIS));
        reportPanel.add(graphPanel);
        
        summaryPanel = new JPanel(true);
        //summaryPanel.setPreferredSize(new Dimension(500,100));
        summaryPanel.setLayout(new BoxLayout(summaryPanel, javax.swing.BoxLayout.Y_AXIS));
        summaryPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Summary"));
        
        parametersPanel = new JPanel(new GridLayout(0, 1, 6, 6), true);
        parametersPanel.setMaximumSize(new Dimension(400,300));
        parametersPanel.setComponentOrientation(ComponentOrientation.LEFT_TO_RIGHT);
        parametersPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("General information"));
        
        startLabel = new JLabel();
        parametersPanel.add(startLabel);
                
        stopLabel = new JLabel();
        parametersPanel.add(stopLabel);
        
        emptyLabel_1 = new JLabel("");
        parametersPanel.add(emptyLabel_1);
        
        protocolLabel = new JLabel();
        parametersPanel.add(protocolLabel);
        
        bandwithLabel = new JLabel();
        parametersPanel.add(bandwithLabel);
        
        intervalLabel = new JLabel();
        parametersPanel.add(intervalLabel);
        
        localIPLabel = new JLabel();
        parametersPanel.add(localIPLabel);
        
        remoteIPLabel = new JLabel();
        parametersPanel.add(remoteIPLabel);
        
        emptyLabel_2 = new JLabel("");
        parametersPanel.add(emptyLabel_2);
        
        modeLabel = new JLabel();
        parametersPanel.add(modeLabel);
        
        fileNameLabel = new JLabel();
        parametersPanel.add(fileNameLabel);
        
        reportFrame.pack();
        reportFrame.setVisible(true);
    
    }
    
}
