/*
 * FileWriter.java
 *
 * Created on 21. april 2007, 15:00
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package my.ABB_UI;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import javax.swing.JRadioButton;
import org.jfree.data.xy.XYSeries;

/**
 *
 * @author ABB
 */
public class WriteToFile {
    
    private generatorManager manager;
    private String fileName;
    private BufferedWriter out;
    
    public XYSeries bandwithSerie_1 = null;
    public XYSeries bandwithSerie_2 = null;
    public XYSeries jitterSerie_1 = null;
    public XYSeries jitterSerie_2 = null;
    public XYSeries lossSerie_1 = null;
    public XYSeries lossSerie_2 = null;
    public XYSeries rxRateSerie_1 = null;
    public XYSeries rxRateSerie_2 = null;
    
    public Object[] channels;
    
    /** Creates a new instance of FileWriter */
    public WriteToFile(generatorManager manager, String fileName) throws IOException {
        this.manager = manager;
        this.fileName = fileName;
        out = new BufferedWriter(new FileWriter(fileName));
    }
    
    public void writeTo() throws IOException{                       
        
        out.write("Start time: " + manager.startTime);
        out.newLine();
        
        out.write("Stop time: " + manager.stopTime);
        out.newLine();
        out.newLine();
        
        out.write("Protocol: " + manager.protocol);
        out.newLine();
        
        out.write("Bandwidth: " + manager.generatorBandwith + "Mbits/sec");
        out.newLine();
        
        out.write("Calculation interval: " + manager.calculationInterval + "s");
        out.newLine();
        
        out.write("Local IP adress: " + manager.localIPAdress);
        out.newLine();
        
        out.write("Remote IP adress: " + manager.remoteIPAdress);
        out.newLine();
        out.newLine();
        
        out.write("WISA BS mode: " + manager.mode);
        out.newLine();
        
        out.write("File name: " + manager.fileName);
        out.newLine();
        out.newLine();
        
        out.write("Muted channels: ");
        for(int i = 0; i < channels.length; i++){
            JRadioButton temp = (JRadioButton) channels[i];
            if(temp.isEnabled() && temp.isSelected()){
                out.write(temp.getText()+ " ");
            }
        }
        out.newLine();
        out.newLine();
                
        if(bandwithSerie_1 != null){
            out.write("**********************************************************");
            out.newLine();
            out.write("Bandwidth data (1st run)");
            out.newLine();
            out.write("Time (s) -- Bandwidth (Mbits/sec)");
            out.newLine();
            
            writeSerie(bandwithSerie_1);
            
            out.newLine();
            out.newLine();
        }
        
        
        if(bandwithSerie_2 != null){
            out.write("**********************************************************");
            out.newLine();
            out.write("Bandwidth data (2nd run)");
            out.newLine();
            out.write("Time (s) -- Bandwidth (Mbits/sec)");
            out.newLine();
            
            writeSerie(bandwithSerie_2);
            
            out.newLine();
            out.newLine();
        }
        
        if(jitterSerie_1 != null){
            out.write("**********************************************************");
            out.newLine();
            out.write("Jitter data (1st run)");
            out.newLine();
            out.write("Time (s) -- Jitter (ms)");
            out.newLine();
            
            writeSerie(jitterSerie_1);
            
            out.newLine();
            out.newLine();
        }
        
        if(jitterSerie_2 != null){
            out.write("**********************************************************");
            out.newLine();
            out.write("Jitter data (2nd run)");
            out.newLine();
            out.write("Time (s) -- Jitter (ms)");
            out.newLine();
            
            writeSerie(jitterSerie_2);
            
            out.newLine();
            out.newLine();
        }
        
        if(lossSerie_1 != null){
            out.write("**********************************************************");
            out.newLine();
            out.write("Datagram loss data (1st run)");
            out.newLine();
            out.write("Time (s) -- Loss (%)");
            out.newLine();
            
            writeSerie(lossSerie_1);
            
            out.newLine();
            out.newLine();
        }
        
        if(rxRateSerie_1 != null){
            out.write("**********************************************************");
            out.newLine();
            out.write("Rate data (1st run)");
            out.newLine();
            out.write("Time (s) -- Rate (Mbits/sec)");
            out.newLine();
            
            writeSerie(rxRateSerie_1);
            
            out.newLine();
            out.newLine();
        }
        if(rxRateSerie_2 != null){
            out.write("**********************************************************");
            out.newLine();
            out.write("Rate data (2nd run)");
            out.newLine();
            out.write("Time (s) -- Rate (Mbits/sec)");
            out.newLine();
            
            writeSerie(rxRateSerie_2);
            
            out.newLine();
            out.newLine();
        }
        if(lossSerie_2 != null){
            out.write("**********************************************************");
            out.newLine();
            out.write("Datagram loss data (2nd run)");
            out.newLine();
            out.write("Time (s) -- Loss (%)");
            out.newLine();
            
            writeSerie(lossSerie_2);
            
            out.newLine();
            out.newLine();
        }
        out.close();
    }
    
    private void writeSerie(XYSeries serie) throws IOException{
        
        for(int i = 0; i < serie.getItemCount(); i++){
            double x = serie.getX(i).doubleValue();
            double y = serie.getY(i).doubleValue();
            
            out.write(x + " -- " + y);
            out.newLine();
        }
    }    
}
