/*
 * wisaBS.java
 *
 * Created on 18. mars 2007, 12:50
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package my.ABB_UI;

import java.awt.Component;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.Scanner;
import java.util.*;
import javax.swing.JRadioButton;
/**
 *
 * @author Erlend
 */
public class wisaBS {
    private char[][] frequencyTable;
    private char[][] muteTable;
    private int noFreqs;
    public char mode = 255;
    private boolean mute = false;
    private boolean useTable = false;
    public boolean off = false;
    /** Creates a new instance of wisaBS */
    public wisaBS() {
        //Defining the size of the tables.
        frequencyTable = new char[2][256];
        muteTable = new char[2][77];
        
        //Filling in the default values in the frequencyTable. All zeroes.
        for(int i = 0; i < frequencyTable[1].length; i++){
            frequencyTable[1][i] = 0;
            frequencyTable[0][i] = (char)i;
        }
        
        //Filling in the defaul values in the muteTable. All zeroes.
        for(int i = 0; i < muteTable[1].length; i++){
            muteTable[1][i] = 0;
            muteTable[0][i] = (char) (i + 3);
        }
    }
    
    public void setOneFreq(int j){
        
        for(int i = 0; i < frequencyTable[1].length; i++){
            frequencyTable[1][i] = 0;
            frequencyTable[0][i] = (char)i;
        }
        
        //Filling in the defaul values in the muteTable. All zeroes.
        for(int i = 0; i < muteTable[1].length; i++){
            muteTable[1][i] = 0;
            muteTable[0][i] = (char) (i + 3);
        }
        
        frequencyTable[1][0] = (char) j;
    }
    
    public void turnOFF(){        
        off = true;
        frequencyTable[1][0] = (char) 79;
        muteTable[1][76] = (char) 1;
        mode = 225;
        noFreqs = 1;
    }
    
   
    public void setMode(Enumeration buttons){
        while(buttons.hasMoreElements()){
            JRadioButton button = (JRadioButton) buttons.nextElement();
            if(button.isSelected()){
                if(button.getText().compareTo("Table") == 0){
                    mode = 225;
//                    System.out.println("Table");
                }
                if(button.getText().compareTo("Normal") == 0){
                    mode = 255;                  
//                    System.out.println("Normal");
                }
            }
        }
    }
    
    public int getMode(){
        return (int) mode;
    }
    //Fills in the frequencyTable with the frequencies specified in the given text file.
    public void readFrequencyFile(String frequencyFile) throws FileNotFoundException{
        Scanner s = null;
        for(int i = 0; i < frequencyTable[1].length; i++){
            frequencyTable[1][i] = 0;
        }
        try {
            s = new Scanner(new BufferedReader(new FileReader(frequencyFile)));
            int i = 0;
            while (s.hasNext() && (i < 256)) {
                int temp = Integer.parseInt(s.next());
                frequencyTable[1][i] = (char) temp;
                i++;
                
            }         
           
            noFreqs = i;
        } finally {
            if (s != null) {
                s.close();
            }
        }         
        
    }
    
    public int getNoFreqs(){
        return noFreqs;
    }
    
    public char[][] getFrequencyTable(){
        return frequencyTable;
    }
    
    public char[][] getMuteTable(){
        return muteTable;
    }
    // Returns an Array of integers with the used frequencies.
    public int[] usedFrequencies(){
       int[] integerFrequency = new int[frequencyTable[1].length];
       for(int i = 0; i < frequencyTable[1].length; i++){
           integerFrequency[i] = (int) frequencyTable[1][i];
       }
       return integerFrequency;
    }
    
    // Fills in the muteTable with the information given by an Array of Components (all the radiobuttons).
    public void muteFreq(Component[] comp){
        for(int i = 0; i < muteTable[1].length; i++){
            muteTable[1][i] = 0;
        }
        for(int i = 0; i < comp.length; i++){
            JRadioButton button = (JRadioButton) comp[i];
            if(button.isSelected() && button.isEnabled()){
                int freqToMute = Integer.valueOf(button.getText());
                //System.out.println(freqToMute);
                muteTable[1][freqToMute-3] = 1;
            }            
        }
    }
}
