/*
 * wisaBSwriter.java
 *
 * Created on 13. mars 2007, 09:20
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package my.ABB_UI;

import java.io.*;
import java.util.*;
//import javax.comm.*;
import gnu.io.*;

/**
 *
 * @author Erlend
 */
public class wisaBSwriter extends Thread {
    
    private SerialPort port;
    private wisaBS basestation;
    private String portName;
    static Enumeration portList;
    /**
     * Creates a new instance of wisaBSwriter
     */
    public wisaBSwriter(wisaBS bs, String port) {
        basestation = bs;
        portName = port;
    }
    
    public wisaBSwriter(String port){
        portName = port;
    }
    
    private void listPorts(){
        portList = CommPortIdentifier.getPortIdentifiers();
        while ( portList.hasMoreElements() ) 
        {
            CommPortIdentifier portId = (CommPortIdentifier) portList.nextElement();
            System.out.println(portId.getName() + " - " + portId.getPortType());
        }        
    }
    /** Establish a connection to a given portname (eg. "COM5")*/
    public void connect(String portName) throws NoSuchPortException{
        CommPortIdentifier portIdentifier;
        
            portIdentifier = CommPortIdentifier.getPortIdentifier(portName);
            if ( portIdentifier.isCurrentlyOwned() )
            {
                System.out.println("Error: Port is currently in use");
            }
            else
            {
                CommPort commPort = null;
                try {
                    commPort = portIdentifier.open(this.getClass().getName(), 2000);
                } catch (PortInUseException ex) {
                    ex.printStackTrace();
                }
            
            
                if ( commPort instanceof SerialPort )
                {
                    port = (SerialPort) commPort;
                    try {
                        port.setSerialPortParams(2400,SerialPort.DATABITS_8,SerialPort.STOPBITS_1,SerialPort.PARITY_NONE);
//                        System.out.println("Success!");
                    } catch (UnsupportedCommOperationException ex) {
                        ex.printStackTrace();
                    }                   
               
                }
                else
                {
                    System.out.println("Error: Only serial ports are handled by this example.");                
                }
            }     
        
        
        
        
    }
    public void close(){
        port.close();
    }
    /** Write 3 bytes to the serial port.*/
    public void write3Bytes(char byte1, char byte2, char byte3){
               
        try {
            OutputStream out = port.getOutputStream();
            out.write(byte1);
            try {
                Thread.sleep(2);
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }
            out.write(byte2);
            try {
                Thread.sleep(2);
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }
            out.write(byte3);
            try {
                Thread.sleep(4);
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }
                            
           
        } catch (IOException ex) {
            ex.printStackTrace();
            
        }
     //System.out.println("Finished writing " + byte3 + " to " + byte1 + byte2);
    }
    
    /** Write 2 bytes to the serial port.*/
    public void write2Bytes(char byte1, char byte2){
                
        try {
            OutputStream out = port.getOutputStream();
            out.write(byte1);
            try {
                Thread.sleep(2);
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }
            out.write(byte2);
            try {
                Thread.sleep(0);
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }
            
        } catch (IOException ex) {
            ex.printStackTrace();
            
        }
       
    }
    
    /** Write to the address field given by the two first inputs. This method is used only after a peephole is established.*/
    public void writeTo(char addr_hi_temp, char addr_lo_temp, char data){
        char byte1 = 7;
        char addr_hi = 13;
        char addr_lo = 12;
        char addr_data = 11;
        
        write3Bytes(byte1, addr_hi, addr_hi_temp);
        write3Bytes(byte1, addr_lo, addr_lo_temp);
        write3Bytes(byte1, addr_data, data);
    }
    
//    public boolean checkAdress(char addr_hi_temp, char addr_lo_temp, char data_to_check){
//        char write_byte = 7;
//        char addr_hi = 13;
//        char addr_lo = 12;
//        char addr_data = 11;
//        char read_byte = 8;
//        
//        write3Bytes(write_byte, addr_hi, addr_hi_temp);
//        write3Bytes(write_byte, addr_hi, addr_lo_temp);
//        write2Bytes(read_byte, addr_data);
//        try {            
//            InputStream in = port.getInputStream();
//            byte[] b = new byte[2];
//            in.read(b, 0, 2);
//            if()
//        } catch (IOException ex) {
//            ex.printStackTrace();
//        }
//        
//    }   
    /** Opens the Peephole. This is necessary to reach the actual adress fields of the WISA BS.*/
    public void enablePeephole(){
        char byte1 = 7;
        char byte2 = 15;
        char byte3 = 132;
       
        write3Bytes(byte1, byte2, byte3);
        //System.out.println("Peephole enabled!");
    }
    
    /** Closes the peephole. Should be done when fisished accessing the WISA BS registers.*/
    public void disablePeephole(){
        char byte1 = 7;
        char byte2 = 15;
        char byte3 = 128;
        //System.out.println("Peephole disabled!");
        write3Bytes(byte1, byte2, byte3);
    }
          
    private void loadFrequencies(){
        char addr_hi = 38;
        int l = basestation.getNoFreqs();
        //System.out.println(l);
        if((basestation.getMode() == 225) && !basestation.off){
            for(int i = 0; i < basestation.getFrequencyTable()[0].length; i++){
                char addr_lo = basestation.getFrequencyTable()[0][i];
                char data = basestation.getFrequencyTable()[1][i];
            
                if((l-1) == (i)){
                    int last =  (int) data + 128;
                    data = (char) last;
                }
            
                writeTo(addr_hi, addr_lo, data);
                if(data != 0.0){
                    //System.out.println("addr_lo = " + ((int)addr_lo) + " -- data = " + ((int)data));
                }
            
            }
        }
        if((basestation.getMode() == 255) && !basestation.off){
            for(int i = 0; i < basestation.getFrequencyTable()[0].length; i++){
                char addr_lo = basestation.getFrequencyTable()[0][i];
                char data = 3;
                writeTo(addr_hi, addr_lo, data);
                if(data != 0.0){
                    //System.out.println("addr_lo = " + ((int)addr_lo) + " -- data = " + ((int)data));
                }
            }
        }
        if(basestation.off){
            for(int i = 0; i < basestation.getFrequencyTable()[0].length; i++){
                char addr_lo = basestation.getFrequencyTable()[0][i];
                char data = basestation.getFrequencyTable()[1][i];
            
                if((l-1) == (i)){
                    int last =  (int) data + 128;
                    data = (char) last;
                }
                
                if(((int)data) != 0 ){
                    //System.out.println("addr_lo = " + ((int)addr_lo) + " -- data = " + ((int)data));
                }
                
                writeTo(addr_hi, addr_lo, data);
                if(data != 0.0){
                    //System.out.println("addr_lo = " + ((int)addr_lo) + " -- data = " + ((int)data));
                }
            
            }
        }
    }
    private void setMode(){
        char addr_hi = 32;
        char addr_lo = 04;
        char data = (char) basestation.getMode();
        //System.out.println("Mode = " + ((int) data));
        writeTo(addr_hi, addr_lo, data);
     
        
    }
    
        
    private void loadMute(){
        char addr_hi = 34;
        if((basestation.getMode() == 225) && !basestation.off){
            for(int i = 0; i < basestation.getMuteTable()[0].length; i++){
                char addr_lo = basestation.getMuteTable()[0][i];
                char data = basestation.getMuteTable()[1][i];
                
                writeTo(addr_hi, addr_lo, data);
                if(data != 0.0){
               }
            }
        }
        if((basestation.getMode() == 255) && !basestation.off){
            for(int i = 0; i < basestation.getMuteTable()[0].length; i++){
                char addr_lo = basestation.getMuteTable()[0][i];
                char data = 0;
                
                writeTo(addr_hi, addr_lo, data);
                if(((int)data) != 0){
               }
            }
        }
        
        if(basestation.off){
            for(int i = 0; i < basestation.getMuteTable()[0].length; i++){
                char addr_lo = basestation.getMuteTable()[0][i];
                char data = basestation.getMuteTable()[1][i];
                
                writeTo(addr_hi, addr_lo, data);
                if(data != 0.0){
               }
            }
        }
    }
    
    public void run(){

        
        enablePeephole();
        
        loadFrequencies();
        loadMute();        
        
        setMode(); 
        disablePeephole();       

        close();
    }
    
}
